﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows;

namespace xamDataChart_setColorToEvryColumn
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            BindChart();
            
        }

        private void BindChart()
        {

            Random rnd = new Random();

            List<Point> list = new List<Point>()
                {
                    new Point(){X= rnd.Next(1,10), SomeLabel = "BG"},
                    new Point(){X = rnd.Next(1,10), SomeLabel = "US"},
                    new Point(){X= rnd.Next(1,10) , SomeLabel= "RO"},
                    new Point(){X =rnd.Next(1,10), SomeLabel = "EURO"},
                    new Point(){X= rnd.Next(1,10) , SomeLabel = "Unknown"},
                    new Point(){X = rnd.Next(1,10), SomeLabel = "FR"},
                    new Point(){X= rnd.Next(1,10) , SomeLabel = "IKEA"},
                };

            GETPoints.Points = list;

            xamDataChart1.DataContext = null;
            xamDataChart1.DataContext = GETPoints.Points;
        }

        private void xamDataChart1_LayoutUpdated(object sender, EventArgs e)
        {
            Canvas c = Utilities.GetDescendantFromName(xamDataChart1.Series[0], "RootCanvas") as Canvas;
            List<Point> DataContextList = xamDataChart1.Series[0].ItemsSource as List<Point>;
            if (c.Children.Count >= DataContextList.Count)
                SetColor(c, DataContextList);
        }

        private void SetColor(Canvas c, List<Point> DataContextList)
        {
            object[] arr= new object[c.Children.Count];
            c.Children.CopyTo(arr, 0);

            var columnsList = arr.Where(s => s.GetType() == typeof(Rectangle)).ToArray();

            foreach (Point p in DataContextList)
            {
                //if (PerformValidation(p.X))
                if (p.X > 5)
                {
                    //BeginAnimation();
                    (columnsList[DataContextList.IndexOf(p)] as Rectangle).Fill = Brushes.Red;
                }
                else
                {
                    (columnsList[DataContextList.IndexOf(p)] as Rectangle).Fill = xamDataChart1.Series[0].ActualBrush;
                }
            }
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            BindChart();
        }
    }

    public class GETPoints
    {
        static List<Point> getPoint = new List<Point>();

        public static List<Point> Points
        {
            get
            {
              //  return getPoint;

                //sort the results for better overview
                return getPoint.OrderBy(p => p.X).ToList<Point>(); 
            }
            set
            {
                getPoint = value;

            }
        }
    }

    public class Point
    {
        public string SomeLabel { get; set; }
        public double X { get; set; }
        public double Fx
        {
            get
            {
                return (X * X) + X;
            }
        }
    }

}